/******************************************************************************/
/**
 *
 * @file fip_urv_cmd.h
 *
 * This is the header file for the fip interaction in Hydra
 *
 ******************************************************************************/
#ifndef __FIP_URV_CMD_H
#define __FIP_URV_CMD_H

#ifdef __cplusplus
extern "C" {
#endif

/***************** Macros (Inline Functions) Definitions **********************/
/* Build Data */
#ifndef C_BUILD_DATE
#define C_BUILD_DATE        4102441200
#endif

/* Build HASH */
#ifndef C_GIT_HASH
#define C_GIT_HASH          0xDEADCAFE
#endif

/* CMD Flags */
#define CMD_ERROR           0x00
#define CMD_WRITE_WORD      0x01
#define CMD_READ_WORD       0x02
#define CMD_SET_LEDS        0x03
#define CMD_GET_LEDS        0x04
#define CMD_I2C_TFR         0x05
#define CMD_I2C_STAT        0x06
#define CMD_I2C_BUF         0x07
#define CMD_I2C_MON         0x08
#define CMD_MON_BUF         0x09
#define CMD_STAT_BUF        0x0A
#define CMD_FIP_PING        0x0B
#define CMD_CPU_FLT         0x0C
#define CMD_WRITE_ECC       0x0D
#define CMD_WAIT            0x0E
#define CMD_WRITE_BLOCK     0x0F
#define CMD_ALRM_FLAG       0x40
#define CMD_APP_FLAG        0x80

/* Statistics register map */
#define STAT_ADC_RST        0   /* Number of adc resets */
#define STAT_FANTRAY_RST    1   /* Number of fantray resets */
#define STAT_RATOPUS_ERR    2   /* Number of ratopus errors */
#define STAT_MIN_WD_CNT     3   /* Minimum watchdog counter */
#define STAT_RECOVERY       4   /* Number of recovery reset */
#define STAT_RESET          5   /* Number of reset */
#define STAT_LAST_RST       6   /* Last cpu reset */
#define STAT_CYCLE_CNT      7   /* Number of cycles executed */
#define STAT_FIP_CMD        8   /* Number of FIP commands (incl padding) */
#define STAT_FIP_PAD        9   /* Number of FIP padding command */
#define STAT_BUILD_DATE     10  /* Build date (seconds since 1970-01-01) */
#define STAT_GIT_HASH       11  /* Git commit hash (32b) */
#define STAT_APP0_START     12  /* App0 CPU program address in eNVM */
#define STAT_FIP_WRITES     13  /* Number of FIP writes command */
#define STAT_WRITE_ADDR     14  /* Last write address */
#define STAT_DATA_WR        15
#define STAT_DATA_WDIS      16
#define STAT_NBR            17

#ifdef __cplusplus
}
#endif

#endif /* __FIP_URV_CMD_H */
