/* TB program - load app cpu from FIP, and check mailbox. */
#include <stdint.h>
#include "common.h"

int main (void)
{
        unsigned i;

        /* Clear recovery bit */
        SUPERVISOR->cpu = 0;

        /* Load plc0 ram.  */
        for (i = 0; i < 512 / 4; i++) {
                unsigned w;

                w = REGS->fip_reg[0] << 0;
                w |= REGS->fip_reg[0] << 8;
                w |= REGS->fip_reg[0] << 16;
                w |= REGS->fip_reg[0] << 24;

                REGS->app0_mem[i] = w;

                SUPERVISOR->wd_key = WD_KEY;
        }
        for (; i < 1024 / 4; i += 4) {
                REGS->app0_mem[i + 0] = 0;
                REGS->app0_mem[i + 1] = 0;
                REGS->app0_mem[i + 2] = 0;
                REGS->app0_mem[i + 3] = 0;
                SUPERVISOR->wd_key = WD_KEY;
        }

        /* Start plc0 */
        REGS->app[0].cr = 0;

        REGS->fip_reg[0] = '0';

        /* Wait until a word was written.  */
        while (!(REGS->app[0].mailboxes.status & MBOX_REGS_STATUS_MBIN))
                SUPERVISOR->wd_key = WD_KEY;

        REGS->fip_reg[0] = '1';

        if (REGS->app[0].mailboxes.mboxin != 0x23456789)
                REGS->fip_reg[0] = 'E';

        REGS->app[0].mailboxes.mboxout = 0;

        REGS->fip_reg[0] = '2';

        while (1)
                SUPERVISOR->wd_key = WD_KEY;
}
