#include "common-app.h"

volatile unsigned run;

void init()
{
}

void failure(unsigned v)
{
  SUPERVISOR->dram_scrub_period = v;
  while (1)
    SUPERVISOR->wd_key = WD_KEY;
}

volatile unsigned vvar;

void
main (void)
{
  unsigned cpu;

  SUPERVISOR->wd_period = 128;			/* @ 0x8000c */

  /* Test cpu-fault.  */
  if (SUPERVISOR->force_divergence & 2) {	/* @ 0x80008 */
    SUPERVISOR->wd_key = WD_KEY;
  }

  if (run == 0) {				/* @ 0x40000 */
    run = 1;					/* @ 0x40000 */

    /* Check cpu #1 is under reset  */
    cpu = SUPERVISOR->cpu;			/* @ 0x80004 */
    if (cpu != 2)
      failure(__LINE__);

    /* Recovery */
    asm volatile ("");
    SUPERVISOR->cpu = HYDRA_SUPERVISOR_REGS_CPU_RECOVERY;
    failure(__LINE__);
  }

  /* Check cpu #1 is under reset  */
  cpu = SUPERVISOR->cpu;			/* @ 0x80004 */
  if (cpu != 0x102)
    failure(__LINE__);

  /* Second divergence */
  if (SUPERVISOR->force_divergence & 4) {	/* @ 0x80008 */
    SUPERVISOR->wd_key = WD_KEY;
  }

  failure(__LINE__);
}
